/////////
//Prefs//
/////////
function RPChat_LoadPrefs()
{
	if($RTB::Hooks::ServerControl)
	{
		RTB_registerPref("Enabled",					"Simple RPChat",	"$Pref::Server::RPChat::Enabled",		"bool",																"Server_SimpleRPChat",	true,	false,	false,	false);
		RTB_registerPref("Name to use in RPChat",	"Simple RPChat",	"$Pref::Server::RPChat::RPNames",		"list Username 0 Nickname 1 Firstname 2 Fullname 3 Fullnickname 4",	"Server_SimpleRPChat",	1,		false,	false,	false);
		RTB_registerPref("Use Team Chat as OOC",	"Simple RPChat",	"$Pref::Server::RPChat::TeamChatIsOOC",	"bool",																"Server_SimpleRPChat",	true,	false,	false,	false);
	}
	else
	{
		if($Pref::Server::RPChat::Enabled $= "")
			$Pref::Server::RPChat::Enabled = true;
		
		if($Pref::Server::RPChat::RPNames $= "")
			$Pref::Server::RPChat::RPNames = 1;

		if($Pref::Server::RPChat::TeamChatIsOOC $= "")
			$Pref::Server::RPChat::TeamChatIsOOC = true;
	}
}
RPChat_LoadPrefs();

////////
//Help//
////////
function serverCmdRPChatHelp(%client)
{
	if($Pref::Server::RPChat::Enabled)
	{
		%enabled = " enabled.";
		if($Pref::Server::RPChat::TeamChatIsOOC)
			%enabled = %enabled SPC "Talk in Team Chat to talk OOC.";
		else
			%enabled = %enabled SPC "Talk in Team Chat to talk in RPChat.";
	}
	else
		%enabled = ", but it is disabled.";
	
	%client.chatmessage("\c6This server has Simple RPChat v1" @ %enabled);
	%client.chatmessage("<color:666666>To whisper, begin your message with <");
	%client.chatmessage("<color:ff6666>To shout, end your message with !");
	if($Pref::Server::RPChat::RPNames > 0)
	{
		%client.chatmessage("\c3/setName \c6- Set the full name of your character. You can have a first, middle, and last name.");
		if($Pref::Server::RPChat::RPNames == 1 || $Pref::Server::RPChat::RPNames == 4)
			%client.chatmessage("\c3/setNickName \c6- Use this to set a shorter and easier to recognise name for yourself.");
	}
}

//////////////
//Datablocks//
//////////////

datablock StaticShapeData(fakeShapeNameRPChatShape)
{
	shapeFile = "base/data/shapes/empty.dts";
};

////////////
//Commands//
////////////

function serverCmdSetName(%client, %name1, %name2, %name3)
{
	if($Pref::Server::RPChat::RPNames <= 0)
		return;
	
	%name1 = chatWhiteListFilter(%name1);
	%name1 = StripMLControlChars(%name1);
	%name1 = trim(%name1);
	%name2 = chatWhiteListFilter(%name2);
	%name2 = StripMLControlChars(%name2);
	%name2 = trim(%name2);
	%name3 = chatWhiteListFilter(%name3);
	%name3 = StripMLControlChars(%name3);
	%name3 = trim(%name3);
	
	if(%name1 $= "")
	{
		%client.chatMessage("\c6You forgot to provide a name.");
		return;
	}
	else if(%name2 $= "")
	{
		%client.chatMessage("\c6You forgot to provide a last name.");
		return;
	}
	
	if(strLen(%name1) > 25)
	{
		%client.chatmessage("\c6Your first name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if((%name3 $= "" && strLen(%name2) > 25) || strLen(%name3) > 25)
	{
		%client.chatmessage("\c6Your last name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if(strLen(%name2) > 25)
	{
		%client.chatmessage("\c6Your middle name is too long. Only 25 characters are allowed.");
		return;
	}
	
	if(%name3 $= "")
	{
		$RPChat_Player[%client.bl_id, "FirstName"] = %name1;
		$RPChat_Player[%client.bl_id, "MiddleName"] = "";
		$RPChat_Player[%client.bl_id, "LastName"] = %name2;
		
		%client.chatMessage("\c6Your name is now \c3" @ $RPChat_Player[%client.bl_id, "FirstName"] SPC $RPChat_Player[%client.bl_id, "LastName"] @ "\c6.");
		%client.chatMessage("\c6This will be used in official documents and anything of the sort.");
	}
	else
	{
		$RPChat_Player[%client.bl_id, "FirstName"] = %name1;
		$RPChat_Player[%client.bl_id, "MiddleName"] = %name2;
		$RPChat_Player[%client.bl_id, "LastName"] = %name3;
		
		%client.chatMessage("\c6Your name is now \c3" @ $RPChat_Player[%client.bl_id, "FirstName"] SPC $RPChat_Player[%client.bl_id, "MiddleName"] SPC $RPChat_Player[%client.bl_id, "LastName"] @ "\c6.");
		%client.chatMessage("\c6This will be used in official documents and anything of the sort.");
	}
	
	export("$RPChat_Player" @ %client.BL_ID @ "_*", "config/server/SimpleRPChat/playersaves/" @ %client.BL_ID @ ".cs");
}

function serverCmdSetNickName(%client, %nick1, %nick2, %nick3, %nick4, %nick5)
{
	if($Pref::Server::RPChat::RPNames <= 0)
		return;

	%full = %nick1 SPC %nick2 SPC %nick3 SPC %nick4 SPC %nick5;
	%full = chatWhiteListFilter(%full);
	%full = StripMLControlChars(%full);
	%full = trim(%full);
	
	if(strLen(%full) > 35)
	{
		%client.chatmessage("Your nickname is too long. Only 35 characters are allowed.");
		return;
	}
	
	if(%full !$= "")
	{
		$RPChat_Player[%client.bl_id, "NickName"] = %full;
		
		%client.chatMessage("\c6Your nickname is now \c3" @ $RPChat_Player[%client.bl_id, "NickName"] @ "\c6.");
		%client.chatMessage("\c6This will be your visible name when used in casual situations.");
	}
	else
		%client.chatMessage("\c6You forgot to provide a name.");
	
	export("$RPChat_Player" @ %client.BL_ID @ "_*", "config/server/SimpleRPChat/playersaves/" @ %client.BL_ID @ ".cs");
}

////////
//Gets//
////////
function gameConnection::GetRPName(%this, %type)
{
	if($Pref::Server::RPChat::RPNames > 0)
	{
		if(%type $= "")
		{
			if($Pref::Server::RPChat::RPNames <= 1)
				%type = 0;
			else if($Pref::Server::RPChat::RPNames == 2)
				%type = 3;
			else if($Pref::Server::RPChat::RPNames == 3)
				%type = 1;
			else if($Pref::Server::RPChat::RPNames == 4)
				%type = 2;
		}
		
		%type = mfloor(%type);
		%blid = %this.BL_ID;
		%firstName = $RPChat_Player[%blid, "FirstName"];
		%middleName = $RPChat_Player[%blid, "MiddleName"];
		%lastName = $RPChat_Player[%blid, "LastName"];
		%nickName = $RPChat_Player[%blid, "NickName"];
		
		if(%type <= 0) //nick
		{
			%fullname = %nickName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			
			return %fullname;
		}
		else if(%type == 1) //first middle last
		{
			%fullname = %firstName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			else
			{
				if(%middleName $= "")
					%fullname = %fullname SPC %lastName;
				else
					%fullname = %fullname SPC %middleName SPC %lastName;
			}
			
			return %fullname;
		}
		else if(%type == 2) //first "nick" middle last
		{
			%fullname = %firstName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			else
			{
				if(%nickName $= "" || %nickName $= %firstName)
				{
					if(%middleName $= "")
						%fullname = %fullname SPC %lastName;
					else
						%fullname = %fullname SPC %middleName SPC %lastName;
				}
				else
				{
					%fullname = %fullname @ " \"" @ %nickName @ "\"";
					if(%middleName $= "")
						%fullname = %fullname SPC %lastName;
					else
						%fullname = %fullname SPC %middleName SPC %lastName;
				}
			}
			
			return %fullname;
		}
		else if(%type >= 3) //first
		{
			%fullname = %firstName;
			
			if(%fullname $= "")
				%fullname = %this.name;
			
			return %fullname;
		}
	}
	else
		return %this.name;
}

////////////////////
//Fake Shape Names//
////////////////////

function Player::SetFakePlayerShapeName(%this, %name, %color, %dist, %time)
{
	if(!isObject(%this))
		return;
	
	if(!isObject(%this.tag))
	{
		%this.tag = new StaticShape()
		{
			datablock = fakeShapeNameRPChatShape;
			position = %this.getPosition();
		};
	}
	
	%this.tag.setShapeName(%name);
	%this.tag.setShapeNameColor(%color);
	%this.tag.setShapeNameDistance(%dist);
	setFakeShapeName(%this, %this.tag, %time);
}

function setFakeShapeName(%this, %tag, %time)
{
	cancel(%this.fakeTagSchedule);
	if(isObject(%this) && %this.fakeTagTime > 0)
	{
		if(isObject(%tag))
		{
			%pos = %this.getEyeTransform();
			%tag.settransform(%pos);
			%this.fakeTagTime--;
			%this.fakeTagSchedule = schedule(1, 0, setFakeShapeName, %this, %tag, %this.fakeTagTime);
		}
		else
			error("Error: No Shape");
	}
	else
		%tag.delete();
}

function Player::SetFakePlayerChatShapeName(%this, %name, %color, %dist, %time)
{
	if(!isObject(%this))
		return;
	
	if(!isObject(%this.chatTag))
	{
		%this.chatTag = new StaticShape()
		{
			datablock = fakeShapeNameRPChatShape;
			position = %this.getPosition();
		};
	}
	
	%this.chatTag.setShapeName(%name);
	%this.chatTag.setShapeNameColor(%color);
	%this.chatTag.setShapeNameDistance(%dist);
	setFakeChatShapeName(%this, %this.chatTag, %time);
}

function setFakeChatShapeName(%this, %tag, %time)
{
	cancel(%this.fakeTagChatSchedule);
	if(isObject(%this) && %this.fakeTagTime > 0)
	{
		if(isObject(%tag))
		{
			%pos = %this.getEyeTransform();
			%pos = vectorAdd(%pos, "0 0 -0.5");
			%tag.settransform(%pos);
			%this.fakeTagTime--;
			%this.fakeTagChatSchedule = schedule(1, 0, setFakeChatShapeName, %this, %tag, %this.fakeTagTime);
		}
		else
			error("Error: No Shape");
	}
	else
		%tag.delete();
}

///////////
//Package//
///////////

if(isPackage(GameModeLifeRPChatPackage))
	deactivatePackage(GameModeLifeRPChatPackage);
package GameModeLifeRPChatPackage
{
	function serverCmdMessageSent(%client, %text)
	{
		if($Pref::Server::RPChat::Enabled)
		{
			//determine what type of chatting they are doing
			if(%client.isTeamChatting)
			{
				if($Pref::Server::RPChat::TeamChatIsOOC)
					%client.isOOC = true;
				else
					%client.isOOC = false;
			}
			else
			{
				if($Pref::Server::RPChat::TeamChatIsOOC)
					%client.isOOC = false;
				else
					%client.isOOC = true;
			}
			
			%player = %client.player;
			if(!isObject(%player)) //this will force chat to be ooc if the player is loading or has died etc
				%client.isOOC = true;
			
			//send to its designated chat type
			if(%client.isOOC)
			{
				%oldPrefix = %client.clanPrefix;
			
				%newPrefix = "\c7(\c4OOC\c7) ";
				
				%client.clanPrefix = %newPrefix @ "\c7" @ %oldPrefix;
				parent::serverCmdMessageSent(%client, %text);
				%client.clanPrefix = %oldPrefix;
			}
			else
			{
				//DEFAULT CHAT STUFF
				
				//repeat check
				%trimText = trim(%text);
				if(%client.lastChatText $= %trimText)
				{
					%chatDelta = (getSimTime() - %client.lastChatTime) / getTimeScale();
					if(%chatDelta < 15000.0)
					{
						%client.spamMessageCount = $SPAM_MESSAGE_THRESHOLD;
						messageClient(%client, '', '\c5Do not repeat yourself.');
					}
				}
				%client.lastChatTime = getSimTime();
				%client.lastChatText = %trimText;
				
				//text filtering
				%text = chatWhiteListFilter(%text);
				%text = StripMLControlChars(%text);
				%text = trim(%text);
				if(strlen(%text) <= 0.0)
					return;
				if($Pref::Server::MaxChatLen > 0.0)
				{
					if(strlen(%text) >= $Pref::Server::MaxChatLen)
						%text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
				}
				
				//links
				%protocol = "http://";
				%protocolLen = strlen(%protocol);
				%urlStart = strpos(%text, %protocol);
				if(%urlStart == -1.0)
				{
					%protocol = "https://";
					%protocolLen = strlen(%protocol);
					%urlStart = strpos(%text, %protocol);
				}
				if(%urlStart == -1.0)
				{
					%protocol = "ftp://";
					%protocolLen = strlen(%protocol);
					%urlStart = strpos(%text, %protocol);
				}
				if(%urlStart != -1.0)
				{
					%urlEnd = strpos(%text, " ", %urlStart + 1.0);
					%skipProtocol = 0;
					if(%protocol $= "http://")
						%skipProtocol = 1;
					if(%urlEnd == -1.0)
					{
						%fullUrl = getSubStr(%text, %urlStart, strlen(%text) - %urlStart);
						%url = getSubStr(%text, %urlStart + %protocolLen, strlen(%text) - %urlStart - %protocolLen);
					}
					else
					{
						%fullUrl = getSubStr(%text, %urlStart, %urlEnd - %urlStart);
						%url = getSubStr(%text, %urlStart + %protocolLen, %urlEnd - %urlStart - %protocolLen);
					}
					if(strlen(%url) > 0.0)
					{
						%url = strreplace(%url, "<", "");
						%url = strreplace(%url, ">", "");
						if (%skipProtocol)
							%newText = strreplace(%text, %fullUrl, "<a:" @ %url @ ">" @ %url @ "</a>\c6");
						else
							%newText = strreplace(%text, %fullUrl, "<a:" @ %protocol @ %url @ ">" @ %url @ "</a>\c6");
						%text = %newText;
					}
				}
				
				//etard
				if($Pref::Server::ETardFilter)
				{
					if(!chatFilter(%client, %text, $Pref::Server::ETardList, '\c5This is a civilized game.  Please use full words.'))
						return;
				}
				
				//player talk animation
				%player.playThread(3, talk);
				%player.schedule(strlen(%text) * 50.0, playThread, 3, root);
				
				//LIFERP CHAT STUFF
				
				%name = %client.GetRPName();
				
				%textAmt = trim(%text);
				%textAmt = strLen(%textAmt);
				if(getSubStr(%text, 0, 1) $= "<")
					%client.isWhispering = true;
				else if(getSubStr(%text, %textAmt - 1, %textAmt) $= "!")
					%client.isShouting = true;
				
				%player.fakeTagTime = mfloor(%textAmt * 50);
				if(%player.fakeTagTime < 500)
					%player.fakeTagTime = 500;
				if(%player.fakeTagTime > 10000)
					%player.fakeTagTime = 10000;
				%player.setShapeNameDistance(0);
				
				if(%client.isWhispering)
				{
					%range = 2;
					%tagRange = 8;
					%color = "0.4 0.4 0.4 1";
				}
				else if(%client.isShouting)
				{
					%range = 50;
					%tagRange = 55;
					%color = "1 0.4 0.4 1";
				}
				else
				{
					%range = 15;
					%tagRange = 20;
					%color = "1 1 1 1";
				}
				
				%player.SetFakePlayerShapeName(%name, "1 1 0 1", %tagRange, %player.fakeTagTime);
				%player.SetFakePlayerChatShapeName(%text, %color, %tagRange, %player.fakeTagTime);
				
				InitContainerRadiusSearch(%player.position, %range, $TypeMasks::PlayerObjectType);
				while((%target = containerSearchNext()) !$= 0)
				{
					%targetClient = %target.client;
					
					if(isObject(%targetClient))
					{
						if(%target != %player && %target = %targetClient.player)
						{
							%target.fakeTagTime = %player.fakeTagTime;
							
							%target.SetFakePlayerShapeName("!!!", "0 1 1 1", %tagRange, %target.fakeTagTime);
							%target.SetFakePlayerChatShapeName(" ", %color, %tagRange, %player.fakeTagTime);
						}
					
						if(%client.isWhispering)
							%targetClient.chatMessage("\c3" @ %name @ "<color:666666>: " @ %text);
						else if(%client.isShouting)
							%targetClient.chatMessage("\c3" @ %name @ "<color:ff6666>: " @ %text);
						else
							%targetClient.chatMessage("\c3" @ %name @ "\c6: " @ %text);
					}
				}
				
				echo("(" @ %client.name @ ") " @ %name @ ": " @ %text);
			}
			
			//tell player there is an rp chat system
			if($Pref::Server::RPChat::TeamChatIsOOC)
			{
				if(mfloor(%client.knowsOOCChat) <= 0)
				{
					%client.chatMessage("\c6Once ingame, you must use team chat, default \"Y\", to talk OOC!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 1)
				{
					%client.chatMessage("\c6Yeah, talk into team chat, default \"Y\", to talk Out Of Character!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 2)
				{
					%client.chatMessage("\c6I hope you know to talk into team chat, default \"Y\", to talk OOC! This is the last I'll tell you! Have fun!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
			}
			else if(!$Pref::Server::RPChat::TeamChatIsOOC)
			{
				if(mfloor(%client.knowsOOCChat) <= 0)
				{
					%client.chatMessage("\c6Once ingame, you must use team chat, default \"Y\", to talk in RP chat!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 1)
				{
					%client.chatMessage("\c6Yeah, talk into team chat, default \"Y\", to talk in RolePlay Chat!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
				else if(mfloor(%client.knowsOOCChat) <= 2)
				{
					%client.chatMessage("\c6I hope you know to talk into team chat, default \"Y\", to talk in RP chat! This is the last I'll tell you! Have fun!");
					%client.chatMessage("\c6If you need more help, use the \c3/rpChatHelp\c6 command.");
					%client.knowsOOCChat++;
				}
			}
			
			%client.isShouting = false;
			%client.isWhispering = false;
			%client.isOOC = false;
		}
		else
			parent::serverCmdMessageSent(%client, %text);
	}
	
	function serverCmdTeamMessageSent(%client, %text)
	{
		if($Pref::Server::RPChat::Enabled)
		{
			%client.isTeamChatting = true;
			serverCmdMessageSent(%client, %text);
			%client.isTeamChatting = false;
		}
		else
			parent::serverCmdTeamMessageSent(%client, %text);
	}
	
	function player::setShapeNameDistance(%this, %dist)
	{
		if($Pref::Server::RPChat::Enabled)
			%dist = 0;
		
		parent::setShapeNameDistance(%this, %dist);
	}
	
	function GameConnection::spawnPlayer(%this)
	{
		Parent::spawnPlayer(%this);
		
		if($Pref::Server::RPChat::Enabled)
			%this.player.setShapeNameDistance(0);
	}
	
	//fake shape name stuff
	function MiniGameSO::reset(%this, %client)
	{
		for(%i = 0; %i < missionCleanup.getCount(); %i++)
		{
			%obj = missionCleanup.getObject(%i);
			if(%obj.getClassName() $= "StaticShape")
			{
				if(%obj.getDatablock() == fakeShapeNameRPChatShape.getID())
					%obj.delete();
			}
		}
		Parent::reset(%this, %client);
	}
};
activatePackage(GameModeLifeRPChatPackage);